# Interface ConeSearcher

All Known Implementing Classes:
  `JdbcConeSearcher, ServiceConeSearcher, SiaConeSearcher, SsaConeSearcher`

public interface ConeSearcher
Object which can perform repeated sky cone searches.

Since:
  10 Aug 2007
Author:
  Mark Taylor

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Called when this searcher is no longer required.
`int`
`getDecIndex(uk.ac.starlink.table.StarTable result)`
Returns the index of a column giving the declination in the returned table.
`int`
`getRaIndex(uk.ac.starlink.table.StarTable result)`
Returns the index of a column giving the right ascension in the returned table.
`uk.ac.starlink.table.StarTable`
`performSearch(double ra, double dec, double sr)`
Returns a table consisting of all the objects within a given search radius of a specified point on the sky.

## Method Details

### performSearch

uk.ac.starlink.table.StarTable performSearch(double ra, double dec, double sr) throws IOException
Returns a table consisting of all the objects within a given search radius of a specified point on the sky. If no matching objects are found, then it is preferable to return an empty table with the correct columns. However, if this cannot be done, it is permissible to return null. For every table returned, the columns should be the same.

Parameters:
  `ra` - right ascension in degrees of search region centre
  `dec` - declination in degrees of search region centre
  `sr` - search radius in degrees
Returns:
  table containing records in the given cone, or possibly null if no records are found
Throws:
  `IOException`

### getRaIndex

int getRaIndex(uk.ac.starlink.table.StarTable result)
Returns the index of a column giving the right ascension in the returned table. This should be the same quantity which is used for the match assessment.

Parameters:
  `result` - table returned by `performSearch`
Returns:
  index of RA column, or -1 if it can't be found

### getDecIndex

int getDecIndex(uk.ac.starlink.table.StarTable result)
Returns the index of a column giving the declination in the returned table. This should be the same quantity which is used for the match assessment.

Parameters:
  `result` - table returned by `performSearch`
Returns:
  index of dec column, or -1 if it can't be found

### close

void close()
Called when this searcher is no longer required.